/*
 *  H8 Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	h8mon.S -- H8 Monitor
 */

#if TARGET_CPU == 3048

#include "3048.h"

#endif	/* of #ifdef TARGET_CPU == 3048 */

#if TARGET_CPU == 3052

#include "3052.h"

#endif	/* of #ifdef TARGET_CPU == 3052 */

#if TARGET_CPU == 3068

#include "3068.h"

#endif	/* of #ifdef TARGET_CPU == 3068 */

#if TARGET_CPU == 3069

#include "3069.h"

#endif	/* of #ifdef TARGET_CPU == 3069 */

#include "serial.h"
#include "comdefs.h"
#include "mondefs.h"
#include "h8mon.h"

		.h8300h

		.text
		.align		2

/*	Start Monitor		*/

_Main:
		mov.l		#STACK_TOP, sp
		mov.l		#_MonitorVector, er0
		mov.l		er0, @CurrentVector
		mov.l		@_BeforeInitEntry, er0
		beq		Main1
		jsr		@er0
Main1:
		bsr		InitVec:16
		bsr		InitTerm
		mov.l		@_AfterInitEntry, er0
		beq		Main2
		jsr		@er0
Main2:
		andc.b		#~CCR_INTERRUPT, ccr	/* enable interrupt on CCR */

#ifdef MULTIPLE_CONSOLE

		sub.l		er3, er3
Main3:
		mov.l		#HelpStrings, er4
		bsr		_SendLine:16
		bsr		_SendPrompt
		inc.l		#1, er3
		cmp.b		#MAX_SERIAL, r3l
		blo		Main3
MainLoop:
		sub.l		er3, er3
MainLoop1:
		bsr		_ParseCmdCore:16
		inc.l		#1, er3
		cmp.b		#MAX_SERIAL, r3l
		blo		MainLoop1
		bra		MainLoop

#else	/* of #ifdef MULTIPLE_CONSOLE */

#ifdef LOAD_AND_GO_ONLY

		mov.l		#DEF_MON_SERIAL, er3
		mov.l		#HelpStrings, er4
		bsr		_SendLine:16
		bsr		_InitRecLine:16

		mov.l		er3, er4
		bsr		_LoadCommand:16

		mov.b		#DEFAULT_LINE_SIZE + 1, r2l
		mulxu.b		r2l, r3
		add.l		#_InputLine, er3		/* er3: start address */
		mov.b		r4h, @er3			/* r4h: 0x00 */
		bsr		_GoCommand:16
MainLoop:
		bra		MainLoop

#else	/* of #ifdef LOAD_AND_GO_ONLY */

		mov.l		#DEF_MON_SERIAL, er3
		mov.l		#HelpStrings, er4
		bsr		_SendLine:16
		bsr		_SendPrompt:16
MainLoop:
		bsr		_ParseCmdCore:16
		bra		MainLoop

#endif	/* of #ifdef LOAD_AND_GO_ONLY */

#endif	/* of #ifdef MULTIPLE_CONSOLE */

/*	
 *	Initialize Terminal
 */

InitTerm:
		push.l		er4
		push.l		er3

		mov.l		#RAM_BASE, er4
		sub.l		er3, er3
InitTerm1:
		bsr		_InitSerial:16			/* Initialize serial port */
		mov.l		er3, er0
		shll.l		er0
		shll.l		er0
		mov.l		er4, @(_AddressPointer, er0)	/* Initialize address pointer */
		mov.l		er4, @(_DumpPointer, er0)	/* Initialize dump    pointer */
		mov.b		#CMDMODE_ADDR, r1l
		mov.b		r1l, @(_CommandMode, er3)	/* Initialize command mode */
		inc.l		#1, er3
		cmp.b		#MAX_SERIAL, r3l
		blo		InitTerm1
		
		pop.l		er3
		pop.l		er4
		rts

/*
 *	Initialize Intrrupt Vectors
 */

InitVec:
		push.l		er3
		push.l		er4
		push.l		er5

		mov.l		#UserVector, er3
		mov.l		#_MonitorVector, er4
		mov.l		#VECTOR_SIZE, er5
		bsr		_MoveLongInc:16

		pop.l		er5
		pop.l		er4
		pop.l		er3
		rts

/*
 *	Send Prompt	
 *
 *	Input:	er3: Serial Channel #, 0 or 1
 */

_SendPrompt:
		bsr		_MonSendPrompt:16
		mov.b		r3h, @(_Status, er3)
		bsr		_InitRecLine:16
SendPromptEnd:
		rts

/*
 *	Command String and Vector
 */

		.section	.rodata
		.align		4
_CommandVector:
		.long		_EnterWordCmd		/* enter word data command */
		.long		_DumpWordCmd		/* dump word command */
		.long		_DumpByteCmd		/* dump byte command */
		.long		_FillByteCmd		/* fill byte command */
		.long		_LoadCommand		/* load command */
		.long		_GoCommand		/* go command */
		.long		HelpCmd

		.align		4
_CommandString:
		.word		MONCMD_ENTER_WORD
		.word		MONCMD_DUMP_WORD
		.word		MONCMD_DUMP_BYTE
		.word		MONCMD_FILL_BYTE
		.word		MONCMD_LOAD
		.word		MONCMD_GO
		.word		CMDSTR_HELP
		.word		0			/* terminator */

/*
 *	Interrupt Entry
 */

		.text
		.align		2

_IntEntry0x04:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x04, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x08:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x08, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x0c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x0c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x10:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x10, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x14:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x14, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x18:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x18, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x1c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x1c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x20:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x20, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x24:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x24, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x28:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x28, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x2c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x2c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x30:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x30, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x34:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x34, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x38:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x38, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x3c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x3c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x40:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x40, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x44:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x44, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x48:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x48, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x4c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x4c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x50:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x50, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x54:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x54, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x58:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x58, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x5c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x5c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x60:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x60, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x64:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x64, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x68:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x68, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x6c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x6c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x70:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x70, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x74:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x74, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x78:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x78, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x7c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x7c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x80:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x80, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x84:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x84, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x88:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x88, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x8c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x8c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x90:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x90, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x94:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x94, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x98:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x98, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x9c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x9c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xa0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xa0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xa4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xa4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xa8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xa8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xac:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xac, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xb0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xb0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xb4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xb4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xb8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xb8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xbc:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xbc, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xc0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xc0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xc4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xc4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xc8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xc8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xcc:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xcc, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xd0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xd0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xd4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xd4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xd8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xd8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xdc:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xdc, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xe0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xe0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xe4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xe4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xe8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xe8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xec:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xec, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xf0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xf0, r0l
		mov.l		@er0, er1
		beq		IntError:16:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xf4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xf4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xf8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xf8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xfc:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xfc, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

IntError:
		push.w		r0
		mov.b		#DEF_MON_SERIAL, r3l
		bsr		_SendLineTerm:16
		mov.l		#IntErrorMsg1, er4
		bsr		_SendString:16
		pop.w		r3
		shlr.b		r3l
		shlr.b		r3l
		mov.b		r3l, r3h
		mov.b		#DEF_MON_SERIAL, r3l
		bsr		_SendByte:16
		mov.l		#IntErrorMsg2, er4
		bsr		_SendLine:16

IntError1:
		bra		IntError1

		.section	.rodata

IntErrorMsg1:
		.ascii		"Undefined Interrupt: \0"

IntErrorMsg2:
		.ascii		", Shutdowned\0"

		.text
		.align		2

/*
 *	Check Sum
 *
 *	Input:	er3: Input Line + 1
 *	Output:	r0l: Check Sum, 0 if no error
 */

CheckSum:
		push.l		er4
		push.l		er3

		inc.l		#1, er3
		mov.b		#2, r4l		/* get  data length: 1 bytes */
		bsr		_HexASCII2Long:16
		dec.l		#2, er3
		sub.w		e4, e4		/* e4:  check sum */
		mov.b		r0l, r4h	/* r4h: data length */
		inc.b		r4h

CheckSum1:
		bsr		_HexASCII2Long:16	/* er0: data */
		add.w		r0, e4
		dec.b		r4h

CheckSum2:
		bne		CheckSum1
		mov.w		e4, r0

		pop.l		er3
		pop.l		er4
		rts

/*
 *	Load Command
 *
 *	Format: ld
 *
 *	Input:	er4: Serial Channel #, 0 or 1
 */

_LoadCommand:
		push.l		er6
		push.l		er5
		push.l		er3
		push.l		er4

		mov.b		#CMDMODE_ADDR, r0l
		mov.b		r0l, @(_CommandMode, er4)

		mov.b		r4l, r3l		/* r3l: serial channel # */
		sub.l		er5, er5
		bra		LoadCommand2

LoadCommand5:
		mov.b		#4, r4l			/* get address: 2 bytes */
		cmp.b		#'1', r4h		/* '1' for data, address: 2 bytes */
		beq		LoadCommand6
		mov.b		#6, r4l			/* get address: 3 bytes */
		cmp.b		#'2', r4h		/* '2' for data, address: 3 bytes */
		beq		LoadCommand6
		mov.b		#8, r4l			/* get address: 4 bytes */
		cmp.b		#'3', r4h		/* '3' for data, address: 4 bytes */
		bne		LoadCommand1

LoadCommand6:
		bsr		_HexASCII2Long:16
		mov.l		er0, er5		/* er5: address */
		sub.b		r4h, r4h
		shlr.w		r4
		sub.w		r4, e4
		beq		LoadCommand1

LoadCommand7:
		mov.b		#2, r4l			/* data: 1 bytes */
		bsr		_HexASCII2Long:16
		mov.b		r0l, @er5
		inc.l		#1, er5
		dec.w		#1, e4
		bne		LoadCommand7

LoadCommand1:
		mov.l		@sp, er3

LoadCommand2:
		bsr		_InitRecLine:16

LoadCommand21:
		bsr		_RecLineNoEcho:16
		and.l		er0, er0
		beq		LoadCommand21

		mov.l		er0, er3
		mov.b		@er3+, r4l
		cmp.b		#'S', r4l
		bne		LoadCommand1

		bsr		CheckSum:16		/* check sum */
		and.b		r0l, r0l		/* 2' complement, for BUG in c38h */
		beq		LoadCommand3
		inc.b		r0l			/* 1' complement */
		beq		LoadCommand3

		mov.l		@sp, er1
		mov.b		@(_Status, er1), r0l
		bne		LoadCommand3

		mov.l		er5, er6
		mov.b		#ERR_CHECK_SUM, r0l	/* check sum error */
		mov.b		r0l, @(_Status, er1)

LoadCommand3:
		mov.b		@er3+, r4h		/* r4h: record type */

		mov.b		#2, r4l			/* get length: 1 bytes */
		bsr		_HexASCII2Long:16
		mov.w		r0, e4			/* e4:  data length */
		dec.w		#1, e4			/* 1 for check sum */

		cmp.b		#'7', r4h		/* '7' for end of records */
		beq		LoadCommand9
		cmp.b		#'8', r4h		/* '8' for end of records */
		beq		LoadCommand9
		cmp.b		#'9', r4h		/* '9' for end of records */
		bne		LoadCommand5:16

LoadCommand9:
		pop.l		er4

		mov.b		@(_Status, er4), r0l
		beq		LoadCommand10

		push.l		er4
		mov.l		er4, er3
		mov.l		er6, er4
		bsr		_SendLongWord:16
		pop.l		er4

LoadCommand10:
		pop.l		er3
		pop.l		er5
		pop.l		er6
		rts

/*
 *	Go Command
 *
 *	Format: go [<addr>]
 *
 *	Input:	er3: input line
 *		er4: Serial Channel #, 0 or 1
 */

_GoCommand:
		push.l		er5
		push.l		er4
		mov.l		er3, er5
		mov.b		#0xff, r4l
		bsr		_HexASCII2Long:16
		cmp.l		er5, er3
		bne		GoCommand1
		mov.l		@UserVector, er0

GoCommand1:
		mov.l		#UserVector, er1
		orc.b		#CCR_INTERRUPT, ccr		/* disable interrupt on CCR */
		mov.l		er1, @CurrentVector
		jsr		@er0

GoCommand2:
		;bra		GoCommand2
		orc.b		#CCR_INTERRUPT, ccr		/* disable interrupt on CCR */
		mov.l		#_MonitorVector, er1
		mov.l		er1, @CurrentVector
		andc.b		#~CCR_INTERRUPT, ccr		/* enable interrupt on CCR */
		pop.l		er4
		pop.l		er5
		rts

/*
 *	Help Command
 *
 *	Command Format: ?
 *
 *	Input:	er3: input line
 *		er4: Serial Channel #, 0 or 1
 */

HelpCmd:
		push.l		er4

		mov.b		r4l, r3l
		mov.l		#HelpStrings, er4
HelpCmd1:
		bsr		_SendLine:16
		mov.b		@er4, r0l
		bne		HelpCmd1

		pop.l		er4
		rts

		.section	.rodata

HelpStrings:
		.ascii		"H8/"
		.ascii		TARGET_CPU_STR
		.ascii		" Monitor v1.12 Copyright (C) 1999-2004 CSE Tomakomai NCT\0"
		.ascii		"----------------------------------------------------------------------------\0"
		.ascii		"ld             load program          | go[<ad>]       go program\0"
		.ascii		"dw[<ad>[<ln>]] dump word             | db[<ad>[<ln>]] dump byte\0"
		.ascii		"ew[<ad>]       enter word\0"
		.ascii		"fb[<ad>[<ln>[<in>[<ic>[<rp>]]]]] fill byte\0"
		.ascii		"?              help\0"
		.ascii		"\0"

/*
 *	Ordinary Vector Area
 */

		.section	.vector

		.long		_Main			/*  0, 0x00: reset */
		.long		_IntEntry0x04		/*  1, 0x04: reserved */
		.long		_IntEntry0x08		/*  2, 0x08: reserved */
		.long		_IntEntry0x0c		/*  3, 0x0c: reserved */
		.long		_IntEntry0x10		/*  4, 0x10: reserved */
		.long		_IntEntry0x14		/*  5, 0x14: reserved */
		.long		_IntEntry0x18		/*  6, 0x18: reserved */
		.long		_IntEntry0x1c		/*  7, 0x1c: NMI */
		.long		_IntEntry0x20		/*  8, 0x20: trap */
		.long		_IntEntry0x24		/*  9, 0x24: trap */
		.long		_IntEntry0x28		/* 10, 0x28: trap */
		.long		_IntEntry0x2c		/* 11, 0x2c: trap */
		.long		_IntEntry0x30		/* 12, 0x30: IRQ0 */
		.long		_IntEntry0x34		/* 13, 0x34: IRQ1 */
		.long		_IntEntry0x38		/* 14, 0x38: IRQ2 */
		.long		_IntEntry0x3c		/* 15, 0x3c: IRQ3 */
		.long		_IntEntry0x40		/* 16, 0x40: IRQ4 */
		.long		_IntEntry0x44		/* 17, 0x44: IRQ5 */
		.long		_IntEntry0x48		/* 18, 0x48: reserved */
		.long		_IntEntry0x4c		/* 19, 0x4c: reserved */
		.long		_IntEntry0x50		/* 20, 0x50: WOVI */
		.long		_IntEntry0x54		/* 21, 0x54: CMI */
		.long		_IntEntry0x58		/* 22, 0x58: reserved */
		.long		_IntEntry0x5c		/* 23, 0x5c: ADI or reserved */
		.long		_IntEntry0x60		/* 24, 0x60: IMIA0 */
		.long		_IntEntry0x64		/* 25, 0x64: IMIB0 */
		.long		_IntEntry0x68		/* 26, 0x68: OVI0 */
		.long		_IntEntry0x6c		/* 27, 0x6c: reserved */
		.long		_IntEntry0x70		/* 28, 0x70: IMIA1 */
		.long		_IntEntry0x74		/* 29, 0x74: IMIB1 */
		.long		_IntEntry0x78		/* 30, 0x78: OVI1 */
		.long		_IntEntry0x7c		/* 31, 0x7c: reserved */
		.long		_IntEntry0x80		/* 32, 0x80: IMIA2 */
		.long		_IntEntry0x84		/* 33, 0x84: IMIB2 */
		.long		_IntEntry0x88		/* 34, 0x88: OVI2 */
		.long		_IntEntry0x8c		/* 35, 0x8c: reserved */
		.long		_IntEntry0x90		/* 36, 0x90: CIMIA0 */
		.long		_IntEntry0x94		/* 37, 0x94: CIMIB0 */
		.long		_IntEntry0x98		/* 38, 0x98: CIMIA1/CIMIB1 */
		.long		_IntEntry0x9c		/* 39, 0x9c: TOVI0/TOVI1 */
		.long		_IntEntry0xa0		/* 40, 0xa0: CIMIA2 */
		.long		_IntEntry0xa4		/* 41, 0xa4: CIMIA2 */
		.long		_IntEntry0xa8		/* 42, 0xa8: CIMIA3/CIMIB3 */
		.long		_IntEntry0xac		/* 43, 0xac: TOVI2/TOVI3 */
		.long		_IntEntry0xb0		/* 44, 0xb0: DEND0A */
		.long		_IntEntry0xb4		/* 45, 0xb4: DEND0B */
		.long		_IntEntry0xb8		/* 46, 0xb8: DEND1A */
		.long		_IntEntry0xbc		/* 47, 0xbc: DEND1B */
		.long		_IntEntry0xc0		/* 48, 0xc0: reserved */
		.long		_IntEntry0xc4		/* 49, 0xc4: reserved */
		.long		_IntEntry0xc8		/* 50, 0xc8: reserved */
		.long		_IntEntry0xcc		/* 51, 0xcc: reserved */
		.long		_IntEntry0xd0		/* 52, 0xd0: ERI0 */
		.long		_IntEntry0xd4		/* 53, 0xd4: RXI0 */
		.long		_IntEntry0xd8		/* 54, 0xd8: TXI0 */
		.long		_IntEntry0xec		/* 55, 0xdc: TEI0 */
		.long		_IntEntry0xe0		/* 56, 0xe0: ERI1 */
		.long		_IntEntry0xe4		/* 57, 0xe4: RXI1 */
		.long		_IntEntry0xe8		/* 58, 0xe8: TXI1 */
		.long		_IntEntry0xec		/* 59, 0xec: TEI1 */
		.long		_IntEntry0xf0		/* 60, 0xf0: ERI2 or ADI */
		.long		_IntEntry0xf4		/* 61, 0xf4: RXI2 or reserved */
		.long		_IntEntry0xf8		/* 62, 0xf8: TXI2 or reserved */
		.long		_IntEntry0xfc		/* 63, 0xfc: TEI2 or reserved */

/*
 *	H8 Monitor Data
 */

		.section	.mondata

CurrentVector:
		.space		4		/* current vector */

/*
 *	User Vectors
 */

		.section	.uservec

UserVector:
		.space		VECTOR_SIZE

		.end
