OUTPUT_FORMAT("coff-h8300")
OUTPUT_ARCH(h8300h)

ENTRY("_Main")

MEMORY {
	/* for mode 6: 0x00000 -> 0xffffff */

	/* internal ROM area: 0x000000 - 0x01ffff */
	rom		: o = 0x000000, l = 0x020000

        vector		: o = 0x000000, l = 0x000100
	monvec		: o = 0x000100, l = 0x000100
	readonly	: o = 0x000200, l = 0x01fe00


	/* internal RAM area: 0xffdf10 - 0xffff0f */
	ram		: o = 0xffdf10, l = 0x002000

        mondata		: o = 0xffdffc, l = 0x000004
        uservec		: o = 0xffe000, l = 0x000100
        readwrite	: o = 0xffe100, l = 0x001e10

	}

PROVIDE(_BeforeInit = 0);
PROVIDE(_AfterInit = 0);

SECTIONS {

	.vectors : {
		*(.vectors)
	} >vector

	.vector : {
		*(.vector)
	} >vector

	.monvec : {
		*(.monvec)
	} >monvec

	. = ALIGN(4);
	.rodata : {
		. = ALIGN(4);
		*(.rodata)
	} >readonly

	. = ALIGN(4);
	.text :
	{
		. = ALIGN(4);
		*(.text)
	} >readonly

	__mondata_start = . ;
	.mondata   : AT(__mondata_start)
	{
		*(.mondata)
	} >mondata

	__uservec_start = __mondata_start + SIZEOF(.mondata);
	.uservec : AT(__uservec_start)
	{
		*(.uservec)
	} >uservec

	. = ALIGN(4);
	__data_start = __uservec_start + SIZEOF(.uservec);
	.data   : AT(__data_start)
	{
		. = ALIGN(4);
		*(.data)
	} >readwrite

	. = ALIGN(4);
	__bss_start = __data_start + SIZEOF(.data);
	.bss       : AT(__bss_start)
	{
		. = ALIGN(4);
	 	*(.bss)
	} >readwrite
}
